Bug 894072 - boost exceptions broken on el5
Summary: boost exceptions broken on el5
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora EPEL
Classification: Fedora
Component: boost141
Version: el5
Hardware: Unspecified
OS: Linux
unspecified
urgent
Target Milestone: ---
Assignee: Robert Scheck
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2013-01-10 16:08 UTC by Todd Denniston
Modified: 2013-10-23 18:20 UTC (History)
4 users (show)

Fixed In Version: boost141-1.41.0-5.el5
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2013-10-23 18:20:05 UTC
Type: Bug


Attachments (Terms of Use)
minimal autoconf scripts for generating error (boost_test_minimal.3.tar.bz2). (25.41 KB, application/x-bzip)
2013-01-10 16:08 UTC, Todd Denniston
no flags Details
changeset_57764_RHEL5.diff (999 bytes, patch)
2013-01-10 16:18 UTC, Todd Denniston
no flags Details | Diff

Description Todd Denniston 2013-01-10 16:08:40 UTC
Created attachment 676404 [details]
minimal autoconf scripts for generating error (boost_test_minimal.3.tar.bz2).

Description of problem:
On RHEL 5.8 compiling against boost141 worked, on RHEL 5.9  compiling against boost141 fails.

Version-Release number of selected component (if applicable):
boost141-devel-1.41.0-2.el5
boost141-thread-1.41.0-2.el5
basically boost141*-1.41.0-2.el5

How reproducible:
Reliably broken on RHEL 5.9.

Steps to Reproduce:
1.
2.
3.
  
Actual results:
configure:20226: g++ -c -g -O2  -pthread -I/usr/include/boost141 conftest.cc >&5
/usr/include/boost141/boost/exception_ptr.hpp:43: error: looser throw specifier for 'virtual boost::exception_ptr::~exception_ptr()'
/usr/include/boost141/boost/exception/detail/exception_ptr_base.hpp:26: error:   overriding 'virtual boost::exception_detail::exception_ptr_base::~exception_ptr_base() throw ()'


Expected results:
No errors on compile, configure completes.

Additional info:
https://svn.boost.org/trac/boost/ticket/3641
The following change set fixes the issue
https://svn.boost.org/trac/boost/changeset/57764

Comment 1 Todd Denniston 2013-01-10 16:17:05 UTC
It took my return on adding the attachment as Submit...

Steps to Reproduce:
1. tar -xjvf boost_test_minimal.3.tar.bz2
2. cd boost_test
3. ./autogen.sh ; ./configure
4. see 
"checking boost/thread.hpp usability... no
checking boost/thread.hpp presence... yes
configure: WARNING:..."
5. grep -n -5 exception_ptr config.log 


Note: from the boost r57764, only the exception.hpp and exception_ptr.hpp need fixed.
i.e. (for testing purposes)
cd /usr/include/boost141
patch -p 3 < ~/RHEL5.9issue/changeset_57764_RHEL5.diff

and the issue is fixed.

Comment 2 Todd Denniston 2013-01-10 16:18:25 UTC
Created attachment 676407 [details]
changeset_57764_RHEL5.diff

Comment 3 Robert Scheck 2013-01-10 16:19:12 UTC
Todd, does this issue also exist on RHEL 6 - which this package is based on?

Comment 4 Todd Denniston 2013-01-10 19:25:04 UTC
(In reply to comment #3)
> Todd, does this issue also exist on RHEL 6 - which this package is based on?

Unfortunately I don't run any RHEL 6 systems, so I can't say.

It should be possible to replace the boost.m4 file, because the one In my tarball has some stuff to make it work on RHEL5, with a current one from http://github.com/tsuna/boost.m4 and try the set on an RHEL 6 system too.

Comment 5 Todd Denniston 2013-01-10 19:27:23 UTC
I am assuming that the breakage was cause either by an include file change between RHEL5.8 and RHEL5.9 or by one of the compiler changes that occurred at the same time.

Comment 6 Todd Denniston 2013-01-14 17:17:57 UTC
I have been working with a second 5.8 machine, and slowly updating it.
results:
Of all the things that got updated between last 5.8 fix through 5.9 release, the only thing not yet updated and the system still work as expected was gcc (and the redhat-release packages), that is going from gcc 4.1.2-52.el5_8.1 to gcc 4.1.2-54.el5 updated the following list of packages:
 gcc cpp gcc-c++ gcc-gfortran gcc-gnat gcc-objc 
 libgcc libgfortran libgnat libmudflap libmudflap-devel 
 libobjc  libstdc++ libstdc++-devel

My quick delta of the include directory files from each rpm did not show any differences, so I am thinking it was a processing change in one of cpp, gcc or gcc-c++.

Unfortunately that 5.8 machine had to walk out the door for the day.

Comment 7 Todd Denniston 2013-01-15 18:34:10 UTC
Looking at the 5.9 release notes for GCC
https://access.redhat.com/knowledge/docs/en-US/Red_Hat_Enterprise_Linux/5/html/5.9_Technical_Notes/gcc.html

we see BZ#806394 BZ#750545 and BZ#806275 which are all related to exception handling.  Unfortunately all of those tickets are still sequestered (security reasons? still valid for RHEL6?) and I only see "You are not authorized to access bug #______".  Perhaps there is hope that when those are fixed in RHEL6 you'll see the issue there too? :)

Comment 8 Ben Webb 2013-01-23 23:41:01 UTC
I'm also seeing this problem on my RHEL 5.9 machines (both i686 and x86_64). To address comment #3, it does *not* occur on my RHEL 6.3 machines (on either arch).

Comment 9 Robert Scheck 2013-01-23 23:54:27 UTC
Thanks for the feedback. I'll will cause a boost update soon. Originally, I
was waiting for bug #828856 to be addressed as well, but looks like Red Hat
is not very responsive regarding this issue nor plans to fix it for RHEL 6.

Comment 10 Todd Denniston 2013-02-19 17:46:14 UTC
Robert,
Is there any chance we can get an el5 released with the fix above in it?
Of course I would also like to see bug #828856 fixed in el5, but it seems a Moderate Impact CVE Local exploit is not important enough for RH to fix in el6.

Comment 11 Fedora Update System 2013-02-23 03:51:14 UTC
boost141-1.41.0-3.el5 has been submitted as an update for Fedora EPEL 5.
https://admin.fedoraproject.org/updates/boost141-1.41.0-3.el5

Comment 12 Fedora Update System 2013-02-23 20:41:11 UTC
Package boost141-1.41.0-3.el5:
* should fix your issue,
* was pushed to the Fedora EPEL 5 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=epel-testing boost141-1.41.0-3.el5'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-EPEL-2013-0432/boost141-1.41.0-3.el5
then log in and leave karma (feedback).

Comment 13 Fedora Update System 2013-03-14 19:11:04 UTC
boost141-1.41.0-3.el5 has been pushed to the Fedora EPEL 5 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 14 Scott Dial 2013-04-01 20:05:53 UTC
(In reply to comment #8)
> I'm also seeing this problem on my RHEL 5.9 machines (both i686 and x86_64).
> To address comment #3, it does *not* occur on my RHEL 6.3 machines (on
> either arch).

In our office, we saw this error start appearing in RHEL 6.4 (and was not present in RHEL 6.3).

Comment 15 Ben Webb 2013-04-01 20:07:41 UTC
(In reply to comment #14)
> In our office, we saw this error start appearing in RHEL 6.4 (and was not
> present in RHEL 6.3).

See bug #921792 for RHEL 6.

Comment 16 Fedora Update System 2013-10-07 23:43:00 UTC
boost141-1.41.0-5.el5 has been submitted as an update for Fedora EPEL 5.
https://admin.fedoraproject.org/updates/boost141-1.41.0-5.el5

Comment 17 Fedora Update System 2013-10-08 20:37:58 UTC
Package boost141-1.41.0-5.el5:
* should fix your issue,
* was pushed to the Fedora EPEL 5 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=epel-testing boost141-1.41.0-5.el5'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-EPEL-2013-11777/boost141-1.41.0-5.el5
then log in and leave karma (feedback).

Comment 18 Fedora Update System 2013-10-23 18:20:05 UTC
boost141-1.41.0-5.el5 has been pushed to the Fedora EPEL 5 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.